#ifndef _H_96540D255BD450F04498ADFDA8639B2E_DigitalInputEvent_DCPS_H_
#define _H_96540D255BD450F04498ADFDA8639B2E_DigitalInputEvent_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DigitalInputEvent_.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class DigitalInputEvent_TypeSupportInterface;

            typedef DigitalInputEvent_TypeSupportInterface * DigitalInputEvent_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DigitalInputEvent_TypeSupportInterface> DigitalInputEvent_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DigitalInputEvent_TypeSupportInterface> DigitalInputEvent_TypeSupportInterface_out;


            class DigitalInputEvent_DataWriter;

            typedef DigitalInputEvent_DataWriter * DigitalInputEvent_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DigitalInputEvent_DataWriter> DigitalInputEvent_DataWriter_var;
            typedef DDS_DCPSInterface_out < DigitalInputEvent_DataWriter> DigitalInputEvent_DataWriter_out;


            class DigitalInputEvent_DataReader;

            typedef DigitalInputEvent_DataReader * DigitalInputEvent_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DigitalInputEvent_DataReader> DigitalInputEvent_DataReader_var;
            typedef DDS_DCPSInterface_out < DigitalInputEvent_DataReader> DigitalInputEvent_DataReader_out;


            class DigitalInputEvent_DataReaderView;

            typedef DigitalInputEvent_DataReaderView * DigitalInputEvent_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DigitalInputEvent_DataReaderView> DigitalInputEvent_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DigitalInputEvent_DataReaderView> DigitalInputEvent_DataReaderView_out;

            struct DigitalInputEvent_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < DigitalInputEvent_, struct DigitalInputEvent_Seq_uniq_> DigitalInputEvent_Seq;
            typedef DDS_DCPSSequence_var < DigitalInputEvent_Seq> DigitalInputEvent_Seq_var;
            typedef DDS_DCPSSequence_out < DigitalInputEvent_Seq> DigitalInputEvent_Seq_out;

            class  DigitalInputEvent_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DigitalInputEvent_TypeSupportInterface_ptr _ptr_type;
                typedef DigitalInputEvent_TypeSupportInterface_var _var_type;

                static DigitalInputEvent_TypeSupportInterface_ptr _duplicate (DigitalInputEvent_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DigitalInputEvent_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DigitalInputEvent_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DigitalInputEvent_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DigitalInputEvent_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DigitalInputEvent_TypeSupportInterface () {};
                ~DigitalInputEvent_TypeSupportInterface () {};
            private:
                DigitalInputEvent_TypeSupportInterface (const DigitalInputEvent_TypeSupportInterface &);
                DigitalInputEvent_TypeSupportInterface & operator = (const DigitalInputEvent_TypeSupportInterface &);
            };

            class  DigitalInputEvent_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DigitalInputEvent_DataWriter_ptr _ptr_type;
                typedef DigitalInputEvent_DataWriter_var _var_type;

                static DigitalInputEvent_DataWriter_ptr _duplicate (DigitalInputEvent_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DigitalInputEvent_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DigitalInputEvent_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DigitalInputEvent_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DigitalInputEvent_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DigitalInputEvent_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DigitalInputEvent_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DigitalInputEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DigitalInputEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DigitalInputEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DigitalInputEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DigitalInputEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DigitalInputEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DigitalInputEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DigitalInputEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DigitalInputEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DigitalInputEvent_& instance_data) = 0;

            protected:
                DigitalInputEvent_DataWriter () {};
                ~DigitalInputEvent_DataWriter () {};
            private:
                DigitalInputEvent_DataWriter (const DigitalInputEvent_DataWriter &);
                DigitalInputEvent_DataWriter & operator = (const DigitalInputEvent_DataWriter &);
            };

            class  DigitalInputEvent_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DigitalInputEvent_DataReader_ptr _ptr_type;
                typedef DigitalInputEvent_DataReader_var _var_type;

                static DigitalInputEvent_DataReader_ptr _duplicate (DigitalInputEvent_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DigitalInputEvent_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DigitalInputEvent_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DigitalInputEvent_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DigitalInputEvent_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DigitalInputEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DigitalInputEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DigitalInputEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DigitalInputEvent_& instance) = 0;

            protected:
                DigitalInputEvent_DataReader () {};
                ~DigitalInputEvent_DataReader () {};
            private:
                DigitalInputEvent_DataReader (const DigitalInputEvent_DataReader &);
                DigitalInputEvent_DataReader & operator = (const DigitalInputEvent_DataReader &);
            };

            class  DigitalInputEvent_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DigitalInputEvent_DataReaderView_ptr _ptr_type;
                typedef DigitalInputEvent_DataReaderView_var _var_type;

                static DigitalInputEvent_DataReaderView_ptr _duplicate (DigitalInputEvent_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DigitalInputEvent_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DigitalInputEvent_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DigitalInputEvent_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DigitalInputEvent_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DigitalInputEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DigitalInputEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DigitalInputEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DigitalInputEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DigitalInputEvent_& instance) = 0;

            protected:
                DigitalInputEvent_DataReaderView () {};
                ~DigitalInputEvent_DataReaderView () {};
            private:
                DigitalInputEvent_DataReaderView (const DigitalInputEvent_DataReaderView &);
                DigitalInputEvent_DataReaderView & operator = (const DigitalInputEvent_DataReaderView &);
            };
        }

    }

}

#endif
