#ifndef _H_F1B09090969B294690B67A3B86BDB9FA_VersionInfo__H_
#define _H_F1B09090969B294690B67A3B86BDB9FA_VersionInfo__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            namespace VersionInfo_Constants
            {
                const ::DDS::ULongLong SMOOTH_MOVE_START_ = 1ULL;

                const ::DDS::ULongLong GYROSCOPE_3D_DATA_ = 2ULL;

            }

            struct  VersionInfo_
            {
                struct _udid__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::ULong, struct _udid__seq_uniq_ > _udid__seq;
                typedef DDS_DCPSSequence_var< _udid__seq > _udid__seq_var;
                typedef DDS_DCPSSequence_out< _udid__seq > _udid__seq_out;
                ::DDS::String_mgr hardware_;
                ::DDS::String_mgr firmware_;
                ::DDS::String_mgr software_;
                _udid__seq udid_;
                ::DDS::ULongLong features_;
            };

            typedef DDS_DCPSStruct_var<VersionInfo_> VersionInfo__var;
            typedef DDS_DCPSStruct_out < VersionInfo_> VersionInfo__out;

        }

    }

}

#endif /* _H_F1B09090969B294690B67A3B86BDB9FA_VersionInfo__H_ */
