#ifndef _H_F80E023CAA7395B9134AFCC9BC1405D8_CliffEvent__H_
#define _H_F80E023CAA7395B9134AFCC9BC1405D8_CliffEvent__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            namespace CliffEvent_Constants
            {
                const ::DDS::Octet LEFT_ = 0;

                const ::DDS::Octet CENTER_ = 1;

                const ::DDS::Octet RIGHT_ = 2;

                const ::DDS::Octet FLOOR_ = 0;

                const ::DDS::Octet CLIFF_ = 1;

            }

            struct  CliffEvent_
            {
                ::DDS::Octet sensor_;
                ::DDS::Octet state_;
                ::DDS::UShort bottom_;
            };

            typedef DDS_DCPSStruct_var<CliffEvent_> CliffEvent__var;
            typedef CliffEvent_& CliffEvent__out;

        }

    }

}

#endif /* _H_F80E023CAA7395B9134AFCC9BC1405D8_CliffEvent__H_ */
