#ifndef _H_4A42628F6DCA0768D5633D2BD1AD12F6_DockInfraRed__H_
#define _H_4A42628F6DCA0768D5633D2BD1AD12F6_DockInfraRed__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            namespace DockInfraRed_Constants
            {
                const ::DDS::Octet NEAR_LEFT_ = 1;

                const ::DDS::Octet NEAR_CENTER_ = 2;

                const ::DDS::Octet NEAR_RIGHT_ = 4;

                const ::DDS::Octet FAR_LEFT_ = 16;

                const ::DDS::Octet FAR_CENTER_ = 8;

                const ::DDS::Octet FAR_RIGHT_ = 32;

            }

            struct  DockInfraRed_
            {
                struct _data__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Octet, struct _data__seq_uniq_ > _data__seq;
                typedef DDS_DCPSSequence_var< _data__seq > _data__seq_var;
                typedef DDS_DCPSSequence_out< _data__seq > _data__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                _data__seq data_;
            };

            typedef DDS_DCPSStruct_var<DockInfraRed_> DockInfraRed__var;
            typedef DDS_DCPSStruct_out < DockInfraRed_> DockInfraRed__out;

        }

    }

}

#endif /* _H_4A42628F6DCA0768D5633D2BD1AD12F6_DockInfraRed__H_ */
