#ifndef _H_A3CF937A529A7224830A4356BB39A146_ExternalPower__H_
#define _H_A3CF937A529A7224830A4356BB39A146_ExternalPower__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            namespace ExternalPower_Constants
            {
                const ::DDS::Octet PWR_3_3V1A_ = 0;

                const ::DDS::Octet PWR_5V1A_ = 1;

                const ::DDS::Octet PWR_12V5A_ = 2;

                const ::DDS::Octet PWR_12V1_5A_ = 3;

                const ::DDS::Octet OFF_ = 0;

                const ::DDS::Octet ON_ = 1;

            }

            struct  ExternalPower_
            {
                ::DDS::Octet source_;
                ::DDS::Octet state_;
            };

            typedef DDS_DCPSStruct_var<ExternalPower_> ExternalPower__var;
            typedef ExternalPower_& ExternalPower__out;

        }

    }

}

#endif /* _H_A3CF937A529A7224830A4356BB39A146_ExternalPower__H_ */
