#ifndef _H_FF9BE3332F3DB379C8E20F883960F916_RobotStateEvent_DCPS_H_
#define _H_FF9BE3332F3DB379C8E20F883960F916_RobotStateEvent_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RobotStateEvent_.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class RobotStateEvent_TypeSupportInterface;

            typedef RobotStateEvent_TypeSupportInterface * RobotStateEvent_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RobotStateEvent_TypeSupportInterface> RobotStateEvent_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RobotStateEvent_TypeSupportInterface> RobotStateEvent_TypeSupportInterface_out;


            class RobotStateEvent_DataWriter;

            typedef RobotStateEvent_DataWriter * RobotStateEvent_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RobotStateEvent_DataWriter> RobotStateEvent_DataWriter_var;
            typedef DDS_DCPSInterface_out < RobotStateEvent_DataWriter> RobotStateEvent_DataWriter_out;


            class RobotStateEvent_DataReader;

            typedef RobotStateEvent_DataReader * RobotStateEvent_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RobotStateEvent_DataReader> RobotStateEvent_DataReader_var;
            typedef DDS_DCPSInterface_out < RobotStateEvent_DataReader> RobotStateEvent_DataReader_out;


            class RobotStateEvent_DataReaderView;

            typedef RobotStateEvent_DataReaderView * RobotStateEvent_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RobotStateEvent_DataReaderView> RobotStateEvent_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RobotStateEvent_DataReaderView> RobotStateEvent_DataReaderView_out;

            struct RobotStateEvent_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < RobotStateEvent_, struct RobotStateEvent_Seq_uniq_> RobotStateEvent_Seq;
            typedef DDS_DCPSSequence_var < RobotStateEvent_Seq> RobotStateEvent_Seq_var;
            typedef DDS_DCPSSequence_out < RobotStateEvent_Seq> RobotStateEvent_Seq_out;

            class  RobotStateEvent_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RobotStateEvent_TypeSupportInterface_ptr _ptr_type;
                typedef RobotStateEvent_TypeSupportInterface_var _var_type;

                static RobotStateEvent_TypeSupportInterface_ptr _duplicate (RobotStateEvent_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RobotStateEvent_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RobotStateEvent_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RobotStateEvent_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RobotStateEvent_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RobotStateEvent_TypeSupportInterface () {};
                ~RobotStateEvent_TypeSupportInterface () {};
            private:
                RobotStateEvent_TypeSupportInterface (const RobotStateEvent_TypeSupportInterface &);
                RobotStateEvent_TypeSupportInterface & operator = (const RobotStateEvent_TypeSupportInterface &);
            };

            class  RobotStateEvent_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RobotStateEvent_DataWriter_ptr _ptr_type;
                typedef RobotStateEvent_DataWriter_var _var_type;

                static RobotStateEvent_DataWriter_ptr _duplicate (RobotStateEvent_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RobotStateEvent_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RobotStateEvent_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RobotStateEvent_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RobotStateEvent_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RobotStateEvent_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RobotStateEvent_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RobotStateEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RobotStateEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RobotStateEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RobotStateEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RobotStateEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RobotStateEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RobotStateEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RobotStateEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RobotStateEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RobotStateEvent_& instance_data) = 0;

            protected:
                RobotStateEvent_DataWriter () {};
                ~RobotStateEvent_DataWriter () {};
            private:
                RobotStateEvent_DataWriter (const RobotStateEvent_DataWriter &);
                RobotStateEvent_DataWriter & operator = (const RobotStateEvent_DataWriter &);
            };

            class  RobotStateEvent_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RobotStateEvent_DataReader_ptr _ptr_type;
                typedef RobotStateEvent_DataReader_var _var_type;

                static RobotStateEvent_DataReader_ptr _duplicate (RobotStateEvent_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RobotStateEvent_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RobotStateEvent_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RobotStateEvent_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RobotStateEvent_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RobotStateEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RobotStateEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RobotStateEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RobotStateEvent_& instance) = 0;

            protected:
                RobotStateEvent_DataReader () {};
                ~RobotStateEvent_DataReader () {};
            private:
                RobotStateEvent_DataReader (const RobotStateEvent_DataReader &);
                RobotStateEvent_DataReader & operator = (const RobotStateEvent_DataReader &);
            };

            class  RobotStateEvent_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RobotStateEvent_DataReaderView_ptr _ptr_type;
                typedef RobotStateEvent_DataReaderView_var _var_type;

                static RobotStateEvent_DataReaderView_ptr _duplicate (RobotStateEvent_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RobotStateEvent_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RobotStateEvent_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RobotStateEvent_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RobotStateEvent_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RobotStateEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RobotStateEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RobotStateEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RobotStateEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RobotStateEvent_& instance) = 0;

            protected:
                RobotStateEvent_DataReaderView () {};
                ~RobotStateEvent_DataReaderView () {};
            private:
                RobotStateEvent_DataReaderView (const RobotStateEvent_DataReaderView &);
                RobotStateEvent_DataReaderView & operator = (const RobotStateEvent_DataReaderView &);
            };
        }

    }

}

#endif
