#ifndef _H_84B0A579125AA33A61B722310EDFB2C1_Sound__H_
#define _H_84B0A579125AA33A61B722310EDFB2C1_Sound__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            namespace Sound_Constants
            {
                const ::DDS::Octet ON_ = 0;

                const ::DDS::Octet OFF_ = 1;

                const ::DDS::Octet RECHARGE_ = 2;

                const ::DDS::Octet BUTTON_ = 3;

                const ::DDS::Octet ERROR_ = 4;

                const ::DDS::Octet CLEANINGSTART_ = 5;

                const ::DDS::Octet CLEANINGEND_ = 6;

            }

            struct  Sound_
            {
                ::DDS::Octet value_;
            };

            typedef DDS_DCPSStruct_var<Sound_> Sound__var;
            typedef Sound_& Sound__out;

        }

    }

}

#endif /* _H_84B0A579125AA33A61B722310EDFB2C1_Sound__H_ */
