#ifndef _H_2E3B60A7D1B122E8DCA9C90F085FB365_WheelDropEvent_DCPS_H_
#define _H_2E3B60A7D1B122E8DCA9C90F085FB365_WheelDropEvent_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "WheelDropEvent_.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class WheelDropEvent_TypeSupportInterface;

            typedef WheelDropEvent_TypeSupportInterface * WheelDropEvent_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < WheelDropEvent_TypeSupportInterface> WheelDropEvent_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < WheelDropEvent_TypeSupportInterface> WheelDropEvent_TypeSupportInterface_out;


            class WheelDropEvent_DataWriter;

            typedef WheelDropEvent_DataWriter * WheelDropEvent_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < WheelDropEvent_DataWriter> WheelDropEvent_DataWriter_var;
            typedef DDS_DCPSInterface_out < WheelDropEvent_DataWriter> WheelDropEvent_DataWriter_out;


            class WheelDropEvent_DataReader;

            typedef WheelDropEvent_DataReader * WheelDropEvent_DataReader_ptr;
            typedef DDS_DCPSInterface_var < WheelDropEvent_DataReader> WheelDropEvent_DataReader_var;
            typedef DDS_DCPSInterface_out < WheelDropEvent_DataReader> WheelDropEvent_DataReader_out;


            class WheelDropEvent_DataReaderView;

            typedef WheelDropEvent_DataReaderView * WheelDropEvent_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < WheelDropEvent_DataReaderView> WheelDropEvent_DataReaderView_var;
            typedef DDS_DCPSInterface_out < WheelDropEvent_DataReaderView> WheelDropEvent_DataReaderView_out;

            struct WheelDropEvent_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < WheelDropEvent_, struct WheelDropEvent_Seq_uniq_> WheelDropEvent_Seq;
            typedef DDS_DCPSSequence_var < WheelDropEvent_Seq> WheelDropEvent_Seq_var;
            typedef DDS_DCPSSequence_out < WheelDropEvent_Seq> WheelDropEvent_Seq_out;

            class  WheelDropEvent_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef WheelDropEvent_TypeSupportInterface_ptr _ptr_type;
                typedef WheelDropEvent_TypeSupportInterface_var _var_type;

                static WheelDropEvent_TypeSupportInterface_ptr _duplicate (WheelDropEvent_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelDropEvent_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static WheelDropEvent_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelDropEvent_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelDropEvent_TypeSupportInterface_ptr _this () { return this; }


            protected:
                WheelDropEvent_TypeSupportInterface () {};
                ~WheelDropEvent_TypeSupportInterface () {};
            private:
                WheelDropEvent_TypeSupportInterface (const WheelDropEvent_TypeSupportInterface &);
                WheelDropEvent_TypeSupportInterface & operator = (const WheelDropEvent_TypeSupportInterface &);
            };

            class  WheelDropEvent_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef WheelDropEvent_DataWriter_ptr _ptr_type;
                typedef WheelDropEvent_DataWriter_var _var_type;

                static WheelDropEvent_DataWriter_ptr _duplicate (WheelDropEvent_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelDropEvent_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static WheelDropEvent_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelDropEvent_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelDropEvent_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const WheelDropEvent_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const WheelDropEvent_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const WheelDropEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const WheelDropEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const WheelDropEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const WheelDropEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const WheelDropEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const WheelDropEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const WheelDropEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const WheelDropEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (WheelDropEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelDropEvent_& instance_data) = 0;

            protected:
                WheelDropEvent_DataWriter () {};
                ~WheelDropEvent_DataWriter () {};
            private:
                WheelDropEvent_DataWriter (const WheelDropEvent_DataWriter &);
                WheelDropEvent_DataWriter & operator = (const WheelDropEvent_DataWriter &);
            };

            class  WheelDropEvent_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef WheelDropEvent_DataReader_ptr _ptr_type;
                typedef WheelDropEvent_DataReader_var _var_type;

                static WheelDropEvent_DataReader_ptr _duplicate (WheelDropEvent_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelDropEvent_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static WheelDropEvent_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelDropEvent_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelDropEvent_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WheelDropEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WheelDropEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WheelDropEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelDropEvent_& instance) = 0;

            protected:
                WheelDropEvent_DataReader () {};
                ~WheelDropEvent_DataReader () {};
            private:
                WheelDropEvent_DataReader (const WheelDropEvent_DataReader &);
                WheelDropEvent_DataReader & operator = (const WheelDropEvent_DataReader &);
            };

            class  WheelDropEvent_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef WheelDropEvent_DataReaderView_ptr _ptr_type;
                typedef WheelDropEvent_DataReaderView_var _var_type;

                static WheelDropEvent_DataReaderView_ptr _duplicate (WheelDropEvent_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelDropEvent_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static WheelDropEvent_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelDropEvent_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelDropEvent_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WheelDropEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WheelDropEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WheelDropEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WheelDropEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelDropEvent_& instance) = 0;

            protected:
                WheelDropEvent_DataReaderView () {};
                ~WheelDropEvent_DataReaderView () {};
            private:
                WheelDropEvent_DataReaderView (const WheelDropEvent_DataReaderView &);
                WheelDropEvent_DataReaderView & operator = (const WheelDropEvent_DataReaderView &);
            };
        }

    }

}

#endif
